import { DatabaseOption } from '../types';
import { Sequelize } from 'sequelize';
import { Model, ModelAttributeColumnReferencesOptions, ModelCtor, ModelOptions, ModelValidateOptions } from 'sequelize/types/lib/model';
import { TypeIsDefine } from '../contants/TypeIs';
interface ModelPreference extends TypeIsDefine {
    unique?: boolean | string | {
        name: string;
        msg: string;
    };
    primaryKey?: boolean;
    autoIncrement?: boolean;
    autoIncrementIdentity?: boolean;
    references?: string | ModelAttributeColumnReferencesOptions;
    onUpdate?: string;
    onDelete?: string;
    validate?: ModelValidateOptions;
    connectTo?: ModelCtor<Model>;
    reverseDefine?: boolean;
    secure?: boolean;
}
interface ModelExtraOptions extends ModelOptions {
    with?: string[];
    associate?: () => void;
}
export interface DBModel extends ModelCtor<Model> {
}
export declare const createModel: (name: string, columns: {
    [key: string]: ModelPreference;
}, options?: ModelExtraOptions | undefined) => DBModel;
export declare const dbInit: (options?: DatabaseOption | undefined) => Sequelize | undefined;
export declare const dbAssociate: () => Promise<void>;
export declare const getSequelize: () => Sequelize | undefined;
export declare const getSecureFields: (model?: string | undefined) => string[] | undefined;
export declare const getSecureKey: () => string;
export {};
