"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSecureKey = exports.getSecureFields = exports.getSequelize = exports.dbAssociate = exports.dbInit = exports.createModel = void 0;

var _tslib = require("tslib");

var _sequelize = require("sequelize");

var _TypeIs = require("../contants/TypeIs");

var config = {
  associates: [],
  secures: []
};

var createModel = function createModel(name, columns, options) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _j;

  var _column = {};
  var associates = [];

  if (((_a = options === null || options === void 0 ? void 0 : options["with"]) === null || _a === void 0 ? void 0 : _a.includes('*')) || ((_b = options === null || options === void 0 ? void 0 : options["with"]) === null || _b === void 0 ? void 0 : _b.includes('id'))) {
    _column.id = {
      type: _sequelize.DataTypes.INTEGER,
      autoIncrement: true,
      primaryKey: true,
      allowNull: false,
      comment: '고유키'
    };
  }

  Object.keys(columns).forEach(function (key) {
    var column = columns[key];
    var type = 'function' === typeof column.type ? column.type() : column.type;
    var connectModel = column.connectTo;

    if (connectModel) {
      associates.push(function (o) {
        return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
          return (0, _tslib.__generator)(this, function (_a) {
            switch (_a.label) {
              case 0:
                if (!o) return [3
                /*break*/
                , 3];
                return [4
                /*yield*/
                , o === null || o === void 0 ? void 0 : o.belongsTo(connectModel, {
                  foreignKey: key,
                  as: "__" + key,
                  onDelete: 'CASCADE'
                })];

              case 1:
                _a.sent();

                if (!column.reverseDefine) return [3
                /*break*/
                , 3];
                return [4
                /*yield*/
                , connectModel === null || connectModel === void 0 ? void 0 : connectModel.hasMany(o)];

              case 2:
                _a.sent();

                _a.label = 3;

              case 3:
                return [2
                /*return*/
                ];
            }
          });
        });
      });
      column.connectTo = undefined;
    }

    _column[key] = (0, _tslib.__assign)((0, _tslib.__assign)({}, column), {
      type: ('__dto_name' in type ? _TypeIs.TypeIs.JSON() : type).toSequelize(),
      allowNull: !column.required
    });
  });

  if (((_c = options === null || options === void 0 ? void 0 : options["with"]) === null || _c === void 0 ? void 0 : _c.includes('*')) || ((_d = options === null || options === void 0 ? void 0 : options["with"]) === null || _d === void 0 ? void 0 : _d.includes('created_at'))) {
    _column.created_at = {
      type: _sequelize.DataTypes.DATE,
      allowNull: false,
      defaultValue: _sequelize.DataTypes.NOW,
      comment: '등록일'
    };
  }

  if (((_e = options === null || options === void 0 ? void 0 : options["with"]) === null || _e === void 0 ? void 0 : _e.includes('*')) || ((_f = options === null || options === void 0 ? void 0 : options["with"]) === null || _f === void 0 ? void 0 : _f.includes('updated_at'))) {
    _column.updated_at = {
      type: _sequelize.DataTypes.DATE,
      allowNull: false,
      defaultValue: _sequelize.DataTypes.NOW,
      comment: '수정일'
    };
  }

  var domain = (_g = config.container) === null || _g === void 0 ? void 0 : _g.define(name, _column, (0, _tslib.__assign)((0, _tslib.__assign)({
    timestamps: false,
    charset: 'utf8mb4',
    collate: 'utf8mb4_general_ci',
    underscored: true
  }, options), {
    tableName: name
  }));

  if (domain) {
    var fields = Object.keys(columns).filter(function (v) {
      return columns[v].secure;
    });

    if (fields.length) {
      config.secures.push({
        domain: name,
        fields: fields
      });
    }
  }

  if ((associates === null || associates === void 0 ? void 0 : associates.length) > 0) {
    (_h = config.associates) === null || _h === void 0 ? void 0 : _h.push.apply(_h, associates === null || associates === void 0 ? void 0 : associates.map(function (v) {
      return {
        domain: domain,
        associate: v
      };
    }));
  }

  if (options === null || options === void 0 ? void 0 : options.associate) {
    (_j = config.associates) === null || _j === void 0 ? void 0 : _j.push({
      domain: domain,
      associate: options.associate
    });
  }

  return domain;
};

exports.createModel = createModel;

var dbInit = function dbInit(options) {
  var _a;

  if (!options) return undefined;
  var args = {
    host: options.host,
    port: options.port,
    dialect: options.dialect,
    logging: (options === null || options === void 0 ? void 0 : options.debug) ? console.log : false,
    timezone: (_a = options === null || options === void 0 ? void 0 : options.timezone) !== null && _a !== void 0 ? _a : '+09:00',
    replication: options === null || options === void 0 ? void 0 : options.replication,
    pool: {
      min: 1,
      max: 20,
      idle: 10000,
      acquire: 60000
    },
    retry: {
      max: 3
    }
  };

  if (!(options === null || options === void 0 ? void 0 : options.replication)) {
    args === null || args === void 0 ? true : delete args.replication;
  }

  config.secureKey = options.securekey;
  config.container = new _sequelize.Sequelize(options.scheme, options.username, options.password, args); // console.log('@node :: database initalize.', args);

  return config.container;
};

exports.dbInit = dbInit;

var dbAssociate = function dbAssociate() {
  return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
    var _i, _a, cmd, e_1;

    var _b;

    return (0, _tslib.__generator)(this, function (_c) {
      switch (_c.label) {
        case 0:
          if (!config.container || !config.associates) return [2
          /*return*/
          ];
          _i = 0, _a = config.associates;
          _c.label = 1;

        case 1:
          if (!(_i < _a.length)) return [3
          /*break*/
          , 6];
          cmd = _a[_i];
          _c.label = 2;

        case 2:
          _c.trys.push([2, 4,, 5]);

          return [4
          /*yield*/
          , (_b = cmd.associate) === null || _b === void 0 ? void 0 : _b.call(cmd, cmd.domain)];

        case 3:
          _c.sent();

          return [3
          /*break*/
          , 5];

        case 4:
          e_1 = _c.sent();
          console.warn(e_1);
          return [3
          /*break*/
          , 5];

        case 5:
          _i++;
          return [3
          /*break*/
          , 1];

        case 6:
          console.log('@node :: associate end.');
          return [2
          /*return*/
          ];
      }
    });
  });
};

exports.dbAssociate = dbAssociate;

var getSequelize = function getSequelize() {
  return config.container;
};

exports.getSequelize = getSequelize;

var getSecureFields = function getSecureFields(model) {
  var o = config.secures.find(function (v) {
    return v.domain === model;
  });
  return o === null || o === void 0 ? void 0 : o.fields;
};

exports.getSecureFields = getSecureFields;

var getSecureKey = function getSecureKey() {
  var _a;

  var s = ((_a = config.secureKey) !== null && _a !== void 0 ? _a : 'actbase@node-server') + '****************';
  return s.substring(0, 16);
};

exports.getSecureKey = getSecureKey;