import { FindAndCountOptions, Model, ModelCtor } from 'sequelize/types/lib/model';
import { DataType, ValueObjectDefault } from '../contants/TypeIs';
export interface ValueObject extends ValueObjectDefault {
    defineModel?: ModelCtor<any>;
    map: (o: any) => any;
    collect: (o: any[]) => any[];
    middleware: (options: any, user: any) => FindAndCountOptions;
}
export interface VOProperties {
    type: DataType;
    comment?: string;
    defaultValue?: unknown;
    reference?: string;
    query?: ((args: {
        user?: any;
        association: string;
        exportParams?: {
            [key: string]: unknown;
        };
    }) => string) | string;
    column?: string;
    render?: (data: unknown) => unknown;
    secure?: Boolean;
}
export declare function getDtoDefinitions(): {
    [key: string]: {
        type: string;
        properties: {
            [key: string]: {
                type?: "string" | undefined;
                description?: "string" | undefined;
            };
        };
    };
};
export declare function createDto<T extends Model & {
    [key: string]: unknown;
}>(name: string, properties: {
    [key: string]: VOProperties;
}, entity?: {
    defineModel?: ModelCtor<T>;
}): ValueObject;
