"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPages = getPages;
exports.installRoutes = exports.getJwtToken = exports.createRoute = void 0;

var _tslib = require("tslib");

var _TypeIs = require("../contants/TypeIs");

var _types = require("../types");

var _passportJwt = require("passport-jwt");

var _passport = _interopRequireDefault(require("passport"));

var _express = _interopRequireDefault(require("express"));

var jwt = _interopRequireWildcard(require("jsonwebtoken"));

var _moment = _interopRequireDefault(require("moment"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var config = {
  pages: [],
  swaggers: []
};

function getPages() {
  return config.swaggers;
}

var uriRegex = /\{([a-zA-Z0-9\_]+)\}/g;

var createRoute = function createRoute(request, execute, options) {
  var _a;

  var _b, _c;

  var path = typeof request.uri === 'string' ? {
    path: request.uri
  } : request.uri;
  (_b = path.path.match(uriRegex)) === null || _b === void 0 ? void 0 : _b.forEach(function (text) {
    var str = text.substring(1, text.length - 1);
    if (!path.items) path.items = {};

    if (!path.items[str]) {
      path.items[str] = {
        type: _TypeIs.TypeIs.STRING
      };
    }
  });
  config.pages.push({
    request: (0, _tslib.__assign)((0, _tslib.__assign)({}, request), {
      uri: path
    }),
    execute: execute,
    size: Object.keys((path === null || path === void 0 ? void 0 : path.items) || {}).length || 0,
    options: options
  });

  if (((_c = options.tags) === null || _c === void 0 ? void 0 : _c.length) && options.summary) {
    var parameters_1 = [];

    if (path.items) {
      Object.keys(path.items).forEach(function (name) {
        var _a, _b;

        var t = (_a = path.items) === null || _a === void 0 ? void 0 : _a[name].type;
        var t1 = typeof t === 'function' ? t() : t;
        var t2 = _typeof(t1) === 'object' && 'toSwagger' in t1 ? t1 === null || t1 === void 0 ? void 0 : t1.toSwagger() : t1;
        parameters_1.push((0, _tslib.__assign)((0, _tslib.__assign)({
          name: name
        }, t2), {
          "in": 'path',
          required: true,
          description: (_b = path.items) === null || _b === void 0 ? void 0 : _b[name].comment
        }));
      });
    }

    if (request.query) {
      Object.keys(request.query).forEach(function (name) {
        var _a, _b;

        var t = (_a = request.query) === null || _a === void 0 ? void 0 : _a[name].type;
        var t1 = typeof t === 'function' ? t() : t;
        var t2 = !(_typeof(t1) === 'object' && 'toSwagger' in t1) || typeof t1 === 'string' ? t1 : t1 === null || t1 === void 0 ? void 0 : t1.toSwagger();
        parameters_1.push((0, _tslib.__assign)((0, _tslib.__assign)({
          name: name
        }, t2), {
          "in": 'query',
          description: (_b = request.query) === null || _b === void 0 ? void 0 : _b[name].comment
        }));
      });
    }

    if (options.paging) {
      parameters_1.push((0, _tslib.__assign)((0, _tslib.__assign)({
        name: 'page'
      }, _TypeIs.TypeIs.INT().toSwagger()), {
        "in": 'query',
        description: '표시할 Page',
        example: 0
      }));
      parameters_1.push((0, _tslib.__assign)((0, _tslib.__assign)({
        name: 'limit'
      }, _TypeIs.TypeIs.INT().toSwagger()), {
        "in": 'query',
        description: '한 페이지당 표시 갯수',
        example: 20
      }));

      if ([true, 'sort'].includes(options.paging)) {
        parameters_1.push((0, _tslib.__assign)((0, _tslib.__assign)({
          name: 'sort'
        }, _TypeIs.TypeIs.STRING().toSwagger()), {
          "in": 'query',
          description: '정렬필드'
        }));
        parameters_1.push((0, _tslib.__assign)((0, _tslib.__assign)({
          name: 'dir'
        }, _TypeIs.TypeIs.ENUM('desc', 'asc').toSwagger()), {
          "in": 'query',
          description: '정렬방식'
        }));
      }
    }

    var requestBodyJson_1 = {};

    if (request.body) {
      Object.keys(request.body).forEach(function (key) {
        var _a;

        var pref = (_a = request.body) === null || _a === void 0 ? void 0 : _a[key];
        var type = typeof (pref === null || pref === void 0 ? void 0 : pref.type) === 'function' ? pref === null || pref === void 0 ? void 0 : pref.type() : pref === null || pref === void 0 ? void 0 : pref.type;

        if ('toSwagger' in type) {
          // @ts-ignore
          requestBodyJson_1[key] = (0, _tslib.__assign)((0, _tslib.__assign)({}, type === null || type === void 0 ? void 0 : type.toSwagger()), {
            description: pref === null || pref === void 0 ? void 0 : pref.comment
          });
        }
      });
    }

    var response = typeof request.response === 'function' ? request.response() : request.response;
    var requestBody = undefined;

    if (Object.keys(requestBodyJson_1 || {}).length) {
      var label = request.formdata ? 'multipart/form-data' : 'application/json';
      requestBody = {
        content: (_a = {}, _a[label] = {
          schema: {
            type: 'object',
            properties: requestBodyJson_1
          }
        }, _a)
      };
    }

    config.swaggers.push({
      operationId: request.method + ':' + path.path,
      path: path,
      method: request.method,
      tags: options.tags,
      summary: options.summary,
      description: options.description,
      requestBody: requestBody,
      parameters: parameters_1,
      response: response,
      data: {// security: security,
        // consumes,
        // parameters,
        // resultKey,
        // requestBody,
      }
    });
  }

  return {};
};

exports.createRoute = createRoute;

var getJwtToken = function getJwtToken(req, user, refreshPayload) {
  return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
    return (0, _tslib.__generator)(this, function (_a) {
      return [2
      /*return*/
      , new Promise(function (resolve, reject) {
        req.login(user, {
          session: false
        }, function (err) {
          var _a, _b, _c;

          if (err) {
            reject(err);
            return;
          }

          var expires_in = ((_a = config.auth) === null || _a === void 0 ? void 0 : _a.jwt_expiration) || 30 * 24 * 60 * 60;
          var options = {
            expiresIn: ((expires_in || 0) > 0 ? expires_in : 30 * 24 * 60 * 60) * 100
          };
          var access_token = jwt.sign(user, ((_b = config.auth) === null || _b === void 0 ? void 0 : _b.jwt_secret) || 'defkey', options);
          var refresh_token = jwt.sign(refreshPayload, ((_c = config.auth) === null || _c === void 0 ? void 0 : _c.jwt_secret) || 'defkey');
          resolve({
            access_token: access_token,
            expires_at: (0, _moment["default"])().unix() + expires_in,
            refresh_token: refresh_token,
            token_type: 'bearer'
          });
        });
      })];
    });
  });
};

exports.getJwtToken = getJwtToken;

var installRoutes = function installRoutes(options) {
  return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
    var jwt_config, router, _loop_1, _i, _a, page;

    var _b;

    return (0, _tslib.__generator)(this, function (_c) {
      config.auth = options;

      if (options) {
        jwt_config = {
          jwtFromRequest: _passportJwt.ExtractJwt.fromAuthHeaderAsBearerToken(),
          secretOrKey: options.jwt_secret
        };

        _passport["default"].use('jwt', new _passportJwt.Strategy(jwt_config, function (jwtPayload, done) {
          return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
            var handler, _a, _b, e_1;

            return (0, _tslib.__generator)(this, function (_c) {
              switch (_c.label) {
                case 0:
                  _c.trys.push([0, 2,, 3]);

                  handler = options.handler();
                  _a = done;
                  _b = [null];
                  return [4
                  /*yield*/
                  , handler === null || handler === void 0 ? void 0 : handler(jwtPayload)];

                case 1:
                  _a.apply(void 0, _b.concat([_c.sent()]));

                  return [3
                  /*break*/
                  , 3];

                case 2:
                  e_1 = _c.sent();
                  done(e_1);
                  return [3
                  /*break*/
                  , 3];

                case 3:
                  return [2
                  /*return*/
                  ];
              }
            });
          });
        }));
      }

      router = _express["default"].Router();
      router.use(function (_req, res, next) {
        res.header('Access-Control-Allow-Methods', 'GET, PUT, POST, DELETE, HEAD, OPTIONS');
        res.header('Access-Control-Allow-Origin', '*');
        next();
      });
      router.all('/*', function (_req, res, next) {
        res.header('Access-Control-Allow-Methods', 'GET, PUT, POST, DELETE, HEAD, OPTIONS');
        res.header('Access-Control-Allow-Origin', '*');
        res.header('Access-Control-Allow-Headers', 'X-Requested-With');
        next();
      });
      config.pages.sort(function (a, b) {
        return a.size > b.size ? 1 : a.size < b.size ? -1 : 0;
      });

      _loop_1 = function _loop_1(page) {
        var execute = page.execute,
            request = page.request;
        var route_uri = String('object' === _typeof(request === null || request === void 0 ? void 0 : request.uri) ? request === null || request === void 0 ? void 0 : request.uri.path : request === null || request === void 0 ? void 0 : request.uri);
        route_uri = route_uri.replace(/\{([a-zA-Z0-9\_]+)\}/g, ':$1');
        var method = ((_b = request === null || request === void 0 ? void 0 : request.method) === null || _b === void 0 ? void 0 : _b.toLowerCase()) || 'get';

        var handlePrepare = function handlePrepare(req, res, next) {
          req.user = undefined;

          try {
            var fn = _passport["default"].authenticate('jwt', {
              session: false
            }, function (err, user) {
              return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
                return (0, _tslib.__generator)(this, function (_a) {
                  req.user = undefined;
                  if (!err) req.user = user || undefined;
                  next();
                  return [2
                  /*return*/
                  ];
                });
              });
            });

            fn(req, res, next);
          } catch (e) {
            console.warn(e);
            next();
          }
        };

        var handleExecute = function handleExecute(req, res, next) {
          return (0, _tslib.__awaiter)(void 0, void 0, void 0, function () {
            var user, args, queryFields, _i, _a, key, field, tp, bodyFields, _b, _c, key, field, tp, user_roles, success, _d, _e, sec, cmd, validate, result, output, e_2;

            var _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;

            return (0, _tslib.__generator)(this, function (_v) {
              switch (_v.label) {
                case 0:
                  if (!!execute) return [3
                  /*break*/
                  , 1];
                  res.status(404).json({
                    message: 'not define execute..'
                  });
                  return [3
                  /*break*/
                  , 7];

                case 1:
                  _v.trys.push([1, 6,, 7]);

                  user = req.user;

                  if ((user === null || user === void 0 ? void 0 : user.roles) && typeof user.roles === 'string') {
                    user.roles = JSON.parse(user.roles);
                  }

                  args = {
                    request: req,
                    files: req.files,
                    query: {},
                    path: req.params,
                    body: {},
                    user: user
                  };
                  queryFields = request === null || request === void 0 ? void 0 : request.query;

                  for (_i = 0, _a = Object.keys(req === null || req === void 0 ? void 0 : req.query); _i < _a.length; _i++) {
                    key = _a[_i];
                    field = (_f = queryFields) === null || _f === void 0 ? void 0 : _f[key];
                    tp = (0, _types.parseType)(field === null || field === void 0 ? void 0 : field.type);

                    if (tp.isDto) {
                      args.query[key] = (_g = tp.dto) === null || _g === void 0 ? void 0 : _g.map((_h = req.query) === null || _h === void 0 ? void 0 : _h[key]);
                    } else if (tp.typeIs) {
                      args.query[key] = ((_j = tp.typeIs) === null || _j === void 0 ? void 0 : _j.fixValue) && tp.typeIs.fixValue((_k = req.query) === null || _k === void 0 ? void 0 : _k[key]) || ((_l = req.query) === null || _l === void 0 ? void 0 : _l[key]);
                    } else if (['page', 'limit', 'sort', 'dir'].includes(key)) {
                      args.query[key] = (_m = req.query) === null || _m === void 0 ? void 0 : _m[key];
                    }
                  }

                  bodyFields = !!((_o = request === null || request === void 0 ? void 0 : request.body) === null || _o === void 0 ? void 0 : _o.__dto_name) ? request.body.properties : request === null || request === void 0 ? void 0 : request.body;

                  for (_b = 0, _c = Object.keys(req === null || req === void 0 ? void 0 : req.body); _b < _c.length; _b++) {
                    key = _c[_b];
                    field = bodyFields[key];
                    tp = (0, _types.parseType)(field === null || field === void 0 ? void 0 : field.type);

                    if (tp.isDto) {
                      args.body[key] = (_p = tp.dto) === null || _p === void 0 ? void 0 : _p.map((_q = req.body) === null || _q === void 0 ? void 0 : _q[key]);
                    } else if (tp.typeIs) {
                      args.body[key] = ((_r = tp.typeIs) === null || _r === void 0 ? void 0 : _r.fixValue) ? tp.typeIs.fixValue((_s = req.body) === null || _s === void 0 ? void 0 : _s[key]) : (_t = req.body) === null || _t === void 0 ? void 0 : _t[key];
                    }
                  }

                  if ((request === null || request === void 0 ? void 0 : request.roles) && request.roles.length > 0 && !request.roles.includes('any')) {
                    user_roles = ((_u = user === null || user === void 0 ? void 0 : user.roles) === null || _u === void 0 ? void 0 : _u.map(function (v) {
                      return v.toLowerCase();
                    })) || [];
                    success = false;

                    for (_d = 0, _e = request.roles; _d < _e.length; _d++) {
                      sec = _e[_d];

                      if (sec.indexOf(':') >= 0) {
                        cmd = sec.substring(sec.indexOf(':') + 1);
                        validate = Function('params', 'user', "return (" + cmd + ")");
                        result = validate((0, _tslib.__assign)((0, _tslib.__assign)({}, args.path), args.query), req.user);

                        if (result) {
                          success = true;
                          break;
                        }
                      } else if (user_roles.includes(sec === null || sec === void 0 ? void 0 : sec.toLowerCase())) {
                        success = true;
                      }
                    }

                    if (!success) {
                      throw {
                        status: 401,
                        message: 'Required Permissions..',
                        data: request.roles
                      };
                    }
                  }

                  if (!(execute.length >= 3)) return [3
                  /*break*/
                  , 3];
                  return [4
                  /*yield*/
                  , execute(req, res, next)];

                case 2:
                  return [2
                  /*return*/
                  , _v.sent()];

                case 3:
                  return [4
                  /*yield*/
                  , execute(args)];

                case 4:
                  output = _v.sent();
                  res.status(200).json(output);
                  _v.label = 5;

                case 5:
                  return [3
                  /*break*/
                  , 7];

                case 6:
                  e_2 = _v.sent();

                  if ((e_2 === null || e_2 === void 0 ? void 0 : e_2.status) === 301) {
                    res.redirect(301, e_2.location);
                  } else if (e_2 === null || e_2 === void 0 ? void 0 : e_2.status) {
                    res.status(e_2 === null || e_2 === void 0 ? void 0 : e_2.status).json({
                      message: e_2 === null || e_2 === void 0 ? void 0 : e_2.message,
                      data: e_2 === null || e_2 === void 0 ? void 0 : e_2.data
                    });
                  } else {
                    if (!(e_2 === null || e_2 === void 0 ? void 0 : e_2.status)) {
                      console.warn('>>> ', route_uri);
                      console.warn(e_2);
                    }

                    res.status((e_2 === null || e_2 === void 0 ? void 0 : e_2.status) || 500).json({
                      uri: route_uri,
                      message: e_2 === null || e_2 === void 0 ? void 0 : e_2.message,
                      data: (e_2 === null || e_2 === void 0 ? void 0 : e_2.data) || JSON.stringify(e_2)
                    });
                  }

                  return [3
                  /*break*/
                  , 7];

                case 7:
                  return [2
                  /*return*/
                  ];
              }
            });
          });
        };

        if (method === 'post') {
          router.post(route_uri, handlePrepare, handleExecute);
        } else if (method === 'put') {
          router.put(route_uri, handlePrepare, handleExecute);
        } else if (method === 'delete') {
          router["delete"](route_uri, handlePrepare, handleExecute);
        } else if (method === 'get') {
          router.get(route_uri, handlePrepare, handleExecute);
        } else {
          router.all(route_uri, handlePrepare, handleExecute);
        }
      };

      for (_i = 0, _a = config.pages; _i < _a.length; _i++) {
        page = _a[_i];

        _loop_1(page);
      } // 커스텀 404 페이지


      router.use(function (_req, res) {
        res.type('text/plain');
        res.status(404);
        res.send('404 - Not Found');
      });
      return [2
      /*return*/
      , router];
    });
  });
};

exports.installRoutes = installRoutes;