"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _swaggerUiExpress = _interopRequireDefault(require("swagger-ui-express"));

var _dto = require("./dto");

var _route = require("./route");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var swagger = require('../../assets/swagger-data.json');

var methods = ['get', 'post', 'put', 'delete'];

var swaggerHandler = function swaggerHandler(app, options, prefix) {
  var dto = (0, _dto.getDtoDefinitions)();
  Object.keys(dto).map(function (key) {
    swagger.components.schemas[key] = dto[key];
  });
  swagger.info.title = options.name;
  swagger.info.version = options.version;
  swagger.info.description = options.description;

  if (options.auth) {
    swagger.components.securitySchemes.OAuthLogin.flows.password.tokenUrl = options.auth;
  }

  var pages = (0, _route.getPages)();
  pages.sort(function (a, b) {
    var _a, _b, _c, _d;

    var ix1 = methods.indexOf(a.method.toLowerCase());
    var ix2 = methods.indexOf(b.method.toLowerCase());
    return (((_a = a.tags) === null || _a === void 0 ? void 0 : _a[0]) || 0) > (((_b = b.tags) === null || _b === void 0 ? void 0 : _b[0]) || 0) ? 1 : (((_c = a.tags) === null || _c === void 0 ? void 0 : _c[0]) || 0) < (((_d = b.tags) === null || _d === void 0 ? void 0 : _d[0]) || 0) ? -1 : a.path.path > b.path.path ? 1 : a.path.path < b.path.path ? -1 : ix1 > ix2 ? 1 : ix1 < ix2 ? -1 : 0;
  });
  pages.forEach(function (v) {
    var _a, _b, _c;

    if (!swagger.paths[v.path.path]) swagger.paths[v.path.path] = {};
    var resultData = undefined;

    if ((_a = v.response) === null || _a === void 0 ? void 0 : _a.__dto_name) {
      resultData = {
        $ref: '#/components/schemas/' + ((_b = v.response) === null || _b === void 0 ? void 0 : _b.__dto_name)
      };
    } else {
      // @ts-ignore
      var t1 = v.response; // @ts-ignore

      var t2 = typeof t1 === 'function' ? t1() : t1;

      if (t2 === null || t2 === void 0 ? void 0 : t2.toSwagger) {
        resultData = t2.toSwagger();
      }
    }

    swagger.paths[v.path.path][(_c = v.method) === null || _c === void 0 ? void 0 : _c.toLowerCase()] = {
      tags: v.tags,
      operationId: v.operationId,
      summary: v.summary,
      description: v.description,
      parameters: v.parameters,
      requestBody: v.requestBody,
      responses: {
        200: {
          description: 'OK',
          content: !resultData ? undefined : {
            'application/json': {
              schema: resultData
            }
          }
        }
      }
    };
  });
  app.use('/swagger-ui.html', _swaggerUiExpress["default"].serve, _swaggerUiExpress["default"].setup(undefined, {
    swaggerOptions: {
      url: options.scheme + "://" + options.host + "/api-docs",
      docExpansion: 'none',
      defaultModelExpandsDepth: '100',
      defaultModelExpandDepth: '100'
    }
  })); // @ts-ignore

  app.use('/api-docs', function (req, res) {
    swagger.servers = [{
      url: options.scheme + "://" + (options.host || req.headers.host) + (prefix ? "/" + prefix : '')
    }];
    return res.status(200).json(swagger);
  });
};

var _default = swaggerHandler;
exports["default"] = _default;